# MegaSearch SLA

### 1. 引言
本 MegaSearch 服务级别协议（以下简称“服务级别协议”）由 Zilliz 制定。如果我们未能达到和保持本服务级别协议中说明的每种服务的服务级别，则您有资格获得月度服务费用的部分服务费抵扣。在您的协议期间，这些条款都不会做任何变动。如果续展订购，则在续订期限开始时实行的本服务级别协议的版本将适用于整个续订期限。如果对本服务级别协议有任何重大不利变更，我们应至少提前九十(90)天进行通知。

### 2. 服务内容
MegaSearch 服务基于强大的GPU芯片和大规模并行算法，提供针对特征向量和多维度数据的联合查询。用户可以通过调用 MegaSearch 提供的API或者SDK将 MegaSearch 无缝对接到自己的AI预测业务上。

### 3. 定义
3.1 “服务” 指的是 Zilliz 根据本协议向开发者提供的付费服务(未付费情况，不适用于本协议)

3.2 “索赔” 指客户根据本服务级别协议向Zilliz提交的、有关尚未达到某个服务级别以及客户可获得的服务费抵扣的索赔。

3.3 “客户” 指签订本协议的机构。

3.4 “客户支持” 指 Zilliz 可由此为客户提供帮助以解决服务问题的服务。

3.5 “错误代码”用于指示某项操作出现了问题，例如，5xx 范围内的 HTTP 状态代码。

3.6 “事件” 表示导致无法达到服务级别的任何情况。

3.7 “管理界面” 指由 Zilliz 提供的 web 界面，客户可以通过该界面来管理 MegaSearch 服务。

3.8 “预览版” 指提供用来获得客户反馈的服务或软件的预览版、测试版或其他预发行版。

3.9 “服务费抵扣” 表示针对受影响的服务已经证实的服务索赔，返还给客户的月度服务费用的百分比。

3.10 “服务级别”指定世纪互联选择遵守并据此衡量其所提供的每种服务的服务级别的标准，具体如下所述。

3.11 “服务资源”指某个服务内可供使用的单独资源。

3.12 “成功代码”用于指示某项操作已经成功，例如，2xx 范围内的 HTTP 状态代码。

3.13 “支持时段”指支持某个服务功能或者支持与某个单独产品或服务兼容的时间范围。

### 4. 服务赔偿
#### 4.1 赔偿范围

因 MegaSearch 设计缺陷导致用户所购买的服务无法正常使用，Zilliz 将对不可用时间进行赔偿，但不包括以下原因所导致的服务不可用时间：

4.1.1 Zilliz 预先通知用户后进行系统维护所引起的，包括割接、维修、升级和模拟故障演练。

4.1.2 用户的应用程序或数据信息受到黑客攻击而引起的。

4.1.3 用户维护不当或保密不当致使数据、口令、密码等丢失或泄漏所引起的。

4.1.4 用户的疏忽或由用户授权的操作所引起的。

4.1.5 不可抗力以及意外事件引起的。

4.1.6 其他非 Zilliz 原因所造成的不可用。

#### 4.2 服务费抵扣

4.2.1 针对所描述的每一种服务，下文介绍了服务费抵扣的金额和计算方法。

4.2.2 服务费抵扣是客户针对未能达到任何服务级别的唯一且排他性的救济。

4.2.3 在任何情况下，任何帐单月份内提供的与特定服务或服务资源相关的服务费抵扣都不得超过客户在该帐单月份内用于该服务或服务资源（如果有）的月度服务费用。

#### 4.3 赔偿方案

4.3.1 “最大可用分钟数” 是指在一个帐单月份期间，用户可用 MegaSearch 的总分钟数。

4.3.2 “停机时间” 是指在一个账单月份期间，MegaSearch 的总累计分钟数。当在某一分钟内，客户所有试图与 MegaSearch 建立连接的连续尝试均失败，则将会视该分钟内该数据库不可用。

4.3.4 每月正常服务时间百分比计算公式： 每月正常服务时间百分比 % = (最大可用分钟数 − 停机时间) ÷ 最大可用分钟数

4.3.5 以下服务级别和服务费抵扣适用于客户对 MegaSearch 服务的使用：

|  每月正常服务时间百分比   | 服务费抵扣  |
|  ----  | ----  |
| <99.9%  | 10% |
| <99%  | 25% |

